﻿using System;

namespace pdftron.PDF.Tools.Collections
{
    internal class PinnedFolderInfo
    {
        public string Token { get; }

        public string FolderPath { get; }

        public PinnedFolderInfo(string token, string folderName)
        {
            Token = token;
            FolderPath = folderName;
        }

        public PinnedFolderInfo(string propertyString)
        {
            string[] splitters = { Environment.NewLine };
            string[] splitProperties = propertyString.Split(splitters, StringSplitOptions.RemoveEmptyEntries);
            if (splitProperties.Length >= 2)
            {
                Token = splitProperties[0].Trim();
                FolderPath = splitProperties[1].Trim();
            }
            else
            {
                Token = string.Empty;
                FolderPath = string.Empty;
            }
        }

        public string GetStorageString() => Token + Environment.NewLine + FolderPath;
    }
}
