﻿using System.Windows.Input;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace pdftron.PDF.Tools.Commands.Events
{
    public static class CheckedCommand
    {
        public static readonly DependencyProperty CommandProperty = DependencyProperty.RegisterAttached(
            "Command",
            typeof(ICommand),
            typeof(CheckedCommand),
            new PropertyMetadata(null, OnCommandPropertyChanged));

        public static void SetCommand(DependencyObject d, ICommand value) => d.SetValue(CommandProperty, value);

        public static ICommand GetCommand(DependencyObject d) => (ICommand)d.GetValue(CommandProperty);

        private static void OnCommandPropertyChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            if (d is RadioButton radioButton)
                radioButton.Checked += RadioButton_Checked;
        }

        private static void RadioButton_Checked(object sender, object e)
        {
            RadioButton radioButton = sender as RadioButton;
            var command = GetCommand(radioButton);
            if (command?.CanExecute(sender) == true)
                command.Execute(radioButton.Tag);
        }
    }
}
