﻿using System.Windows.Input;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace pdftron.PDF.Tools.Commands.Events
{
    public static class FlyoutOpenedCommand
    {
        public static readonly DependencyProperty CommandProperty = DependencyProperty.RegisterAttached(
            "Command",
            typeof(ICommand),
            typeof(FlyoutOpenedCommand),
            new PropertyMetadata(null, OnCommandPropertyChanged));

        public static void SetCommand(DependencyObject d, ICommand value) => d.SetValue(CommandProperty, value);

        public static ICommand GetCommand(DependencyObject d) => (ICommand)d.GetValue(CommandProperty);

        private static void OnCommandPropertyChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            if (d is Flyout flyout)
                flyout.Opened += Flyout_Opened;
        }

        private static void Flyout_Opened(object sender, object e)
        {
            Flyout flyout = sender as Flyout;
            var command = GetCommand(flyout);
            if (command?.CanExecute(sender) == true)
                command.Execute(sender);
        }
    }
}
