﻿using System.Threading.Tasks;
using Windows.System;
using Windows.UI.Xaml.Input;

namespace pdftron.PDF.Tools.Controls.ViewModels.Password
{
    public partial class PdfPasswordViewModel
    {
        private async Task ExecutePasswordKeyDownAsync(object parameter)
        {
            if (parameter is KeyRoutedEventArgs args)
            {
                await PasswordKeyDownAsync(args.Key);
            }
        }

        private async Task PasswordKeyDownAsync(VirtualKey key)
        {
            if (key == VirtualKey.Enter)
            {
                await VerifyPasswordAsync();
            }
            else if (key == VirtualKey.Escape)
            {
                await CancelPasswordAsync();
            }
        }
    }
}
