﻿using pdftron.PDF.Tools.Utilities;
using System;
using System.Diagnostics.CodeAnalysis;
using Windows.UI.Xaml.Controls;

namespace pdftron.PDF.Tools.Controls.ViewModels
{
    public partial class ThumbnailsViewViewModel
    {
        [SuppressMessage("Redundancy", "RCS1163:Unused parameter.", Justification = "<Pending>")]
        private void Close(object parameter)
        {
            if (IsInEditMode)
            {
                SelectionMode = ListViewSelectionMode.None;
                IsSelectButtonVisible = true;
                return;
            }

            if (_pdfViewCtrl != null)
            {
                if (_hasModifiedPageLayout)
                {
                    try
                    {
                        _pdfViewCtrl.UpdatePageLayout();
                    }
                    catch (Exception ex)
                    {
                        AnalyticsHandlerBase.CURRENT.SendEvent(
                            AnalyticsHandlerBase.EXCEPTION_EVENT_CATEGORY,
                            AnalyticsHandlerBase.GetExceptionMessage(ex));
                    }
                }
                _pdfViewCtrl.RequestRendering();
                if (CurrentItem?.IsCurrentPage == true)
                {
                    int index = ThumbnailsList.IndexOf(CurrentItem);
                    _pdfViewCtrl.SetCurrentPage(index + 1);
                }
            }

            _view.CloseControl();
            CleanUp();
        }
    }
}
