﻿using pdftron.PDF.Tools.Commands;
using System;
using System.Threading.Tasks;

using Windows.UI.Popups;
using Windows.UI.Xaml.Controls;


namespace pdftron.PDF.Tools.Controls.ViewModels
{
    public partial class ThumbnailsViewViewModel
    {
        private async Task DeleteSelectedPagesAsync(object parameter)
        {
            ContentDialog dialog = new ContentDialog
            {
                PrimaryButtonText = ResourceHandler.GetString("ThumbnailsView_Delete_Message_Confirm"),
                CloseButtonText = ResourceHandler.GetString("ThumbnailsView_Delete_Message_Cancel")
            };

            if (_selectedItems.Count > 1 && parameter == null)
            {
                dialog.Title = ResourceHandler.GetString("ThumbnailsView_Delete_Multiple_Message_Title");
                dialog.Content = string.Format(ResourceHandler.GetString("ThumbnailsView_Delete_Multiple_Message_Content"), _selectedItems.Count);
            }
            else
            {
                dialog.Title = ResourceHandler.GetString("ThumbnailsView_Delete_Single_Message_Title");
                dialog.Content = ResourceHandler.GetString("ThumbnailsView_Delete_Single_Message_Content");
            }

            dialog.PrimaryButtonCommand = new RelayCommand(async (_) =>
            {
                await DeleteItemsAsync(parameter as ThumbnailItem);

                if (ToolManager?.UndoRedoAction != null)
                    ToolManager.UndoRedoAction.TakeSnapshot("Delete Page", true);
            });

            await Utilities.DialogHelper.ShowContentDialogAsync(dialog);
        }
    }
}
