﻿using pdftron.PDF.Tools.Extensions;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace pdftron.PDF.Tools.Controls.ViewModels
{
    public partial class ThumbnailsViewViewModel
    {
        private void ItemClick(object parameter)
        {
            if (parameter is ItemClickEventArgs eargs && eargs.ClickedItem is ThumbnailItem clickedItem && eargs.OriginalSource is ListView listView)
            {
                ListViewItem item = (ListViewItem)listView.ContainerFromItem(clickedItem);
                foreach (var button in item.FindControls<Button>())
                    button.Visibility = Visibility.Visible;

                if (!DoubleTapToNavigate)
                    OpenPage(ThumbnailsList.IndexOf(clickedItem));
            }
        }
    }
}
