﻿using pdftron.PDF.Tools.Commands;
using pdftron.PDF.Tools.Controls.Viewer;
using pdftron.PDF.Tools.Utilities;
using System.Threading.Tasks;
using Windows.ApplicationModel.Resources;
using Windows.UI.Popups;
using Windows.UI.Xaml.Controls;

namespace pdftron.PDF.Tools.Controls.ViewModels.Viewer.ColorMode
{
    public partial class CustomColorViewModel
    {
        private async Task IconClickAsync(object parameter)
        {
            if (!(parameter is ItemClickEventArgs item))
                return;

            CustomColorIconViewModel nextIcon = (CustomColorIconViewModel)item.ClickedItem;
            EditMode = EditModeType.Background;

            if (nextIcon.IsLoadDefault)
            {
                ResourceLoader loader = ResourceLoader.GetForCurrentView("pdftron.PDF.Tools/Resources");

                ContentDialog dialog = new ContentDialog
                {
                    Title = loader.GetString("CustomColorPopup_LoadDefault_Title"),
                    Content = loader.GetString("CustomColorPopup_LoadDefault_Content"),
                    PrimaryButtonText = ResourceLoader.GetForCurrentView("pdftron.PDF.Tools/Resources").GetString("CustomColorPopup_LoadDefault_Ok"),
                    CloseButtonText = ResourceLoader.GetForCurrentView("pdftron.PDF.Tools/Resources").GetString("Generic_Cancel_Text")
                };

                dialog.PrimaryButtonCommand = new RelayCommand((_) => 
                {
                    ViewerSettings.SetDefaultCustomColors();
                    PopulateCustomColorCollection();
                    if (CurrSelectedIcon != null)
                    {
                        CurrSelectedIcon.IsSelected = false;
                        CurrSelectedIcon = null;
                    }
                });

                ChangeIsLightDismissable(false);
                await DialogHelper.ShowContentDialogAsync(dialog);
                ChangeIsLightDismissable(true);
                return;
            }

            if (CurrSelectedIcon != null)
            {
                if (CurrSelectedIcon != nextIcon)
                {
                    CurrSelectedIcon.IsSelected = false;
                }
                else
                {
                    ViewMode = ViewModeType.Edit;
                }
            }

            CurrSelectedIcon = nextIcon;
            CurrSelectedIcon.IsSelected = true;
        }
    }
}
