﻿using pdftron.PDF.Tools.Controls.Viewer;
using System.Diagnostics.CodeAnalysis;

namespace pdftron.PDF.Tools.Controls.ViewModels.Viewer.ColorMode
{
    public partial class CustomColorViewModel
    {
        [SuppressMessage("Redundancy", "RCS1163:Unused parameter.", Justification = "<Pending>")]
        private void SelectCustomColor(object parameter)
        {
            if (ViewMode == ViewModeType.Edit)
            {
                ViewerSettings.SetCustomColorIcon(CurrSelectedIcon.Background, CurrSelectedIcon.Foreground, CustomColorIconCollection.IndexOf(CurrSelectedIcon));
                ViewMode = ViewModeType.Icon;
            }
            else
            {
                // Handle applying chosen custom color
                if (CurrSelectedIcon != null)
                {
                    int index = CustomColorIconCollection.IndexOf(CurrSelectedIcon);
                    if (index != -1)
                        ViewerSettings.CurrentCustomColorIcon = index;

                    _customColorRequested?.Invoke(CurrSelectedIcon);
                }

                IsPopupOpen = false;
            }
        }
    }
}
