﻿using pdftron.Common;
using System;
using System.Diagnostics.CodeAnalysis;

namespace pdftron.PDF.Tools.Controls.ViewModels.Viewer.Crop
{
    public partial class CropPopupViewModel
    {
        /// <summary>
        /// Iterates through all the pages of the PDF and removes all User Crops
        /// </summary>
        [SuppressMessage("Redundancy", "RCS1163:Unused parameter.", Justification = "<Pending>")]
        private void RemoveCropping(object parameter)
        {
            PDFDoc pdfDoc = _pdfViewCtrl.GetDoc();
            bool hasEditedDoc = false;
            try
            {
                pdfDoc.LockRead();
                PageIterator iter = pdfDoc.GetPageIterator();
                int pageNum = 1;
                while (iter.HasNext())
                {
                    Page page = iter.Current();

                    hasEditedDoc |= CropViewViewModel.RemoveUserCropFromPage(page);

                    pageNum++;
                    iter.Next();
                }
            }
            catch (Exception e)
            {
                PDFNetException pdfe = new PDFNetException(e.HResult);
                if (!pdfe.IsPDFNetException)
                    throw;
            }
            finally
            {
                pdfDoc.UnlockRead();
                IsPopupOpen = false;
                _pdfViewCtrl.UpdatePageLayout();
                if (hasEditedDoc)
                    _documentEdited?.Invoke();
            }
        }
    }
}
