﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;

using Windows.ApplicationModel.Resources;
using Windows.UI.Xaml.Controls;

using pdftron.PDF.Tools.Commands;
using pdftron.PDF.Tools.Utilities;


namespace pdftron.PDF.Tools.Controls.ViewModels.Viewer
{
    public partial class ViewerViewModel
    {
        private async Task SaveAndFlattenAsync()
        {
            Utilities.AppCenterHandlerBase.CURRENT.SendEvent("Export", new Dictionary<string, string>() { ["Command"] = "Flatten annotations" });

            TabControlViewModel?.SelectedTab?.ToolManager?.CloseOpenDialog();

            ResourceLoader loader = ResourceLoader.GetForCurrentView("pdftron.PDF.Tools/Resources");

            ContentDialog dialog = new ContentDialog
            {
                Title = loader.GetString("ViewerPage_SecondaryOptions_SaveAndFlatten_Message_Title"),
                Content = loader.GetString("ViewerPage_SecondaryOptions_SaveAndFlatten_Message"),
                PrimaryButtonText = loader.GetString("ViewerPage_SecondaryOptions_SaveAndFlatten_Message_Confirm"),
                CloseButtonText = loader.GetString("Generic_Cancel_Text")

            };

            dialog.PrimaryButtonCommand = new RelayCommand(async _ =>
            {
                IsAppBarOpen = false;
                await SaveAsAsync(TabControlViewModel.SelectedTab, false, false, SaveAsOption.Flatten);
            });

            var result = await DialogHelper.ShowContentDialogAsync(dialog);
        }
    }
}
