﻿using System.Threading.Tasks;

namespace pdftron.PDF.Tools.Controls.ViewModels.Viewer
{
    public partial class ViewerViewModel
    {
        private async Task SaveAsync()
        {
            if (TabControlViewModel != null)
            {
                _saveRequested?.Invoke(TabControlViewModel.SelectedTab);
            }

            if (IsExternalSaveEnabled)
                return;

            CloseCurrentTool();
            AppbarInteraction();
            TabControlViewModel?.SelectedTab?.ToolManager?.CloseOpenDialog();
            await SaveImplAsync();
            IsAppBarOpen = false;

            if (_savingInProgress)
            {
                PDFViewCtrl.IsEnabled = false;
                CurrentSaveAsOption = SaveAsOption.Save;
                IsSaveTimerOpen = true;
            }
        }
    }
}
