﻿using pdftron.PDF.Tools.Controls.ViewModels;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

namespace pdftron.PDF.Tools.Controls
{
    public sealed partial class MagnifyingControl : UserControl
    {
        private MagnifyingControlViewModel _ViewModel;
        public MagnifyingControlViewModel ViewModel
        {
            get { return _ViewModel; }
            set { _ViewModel = value; }
        }
        public MagnifyingControl()
        {
            this.InitializeComponent();
            ViewModel = new MagnifyingControlViewModel();
            DataContext = ViewModel;
            StretchedGrid.SizeChanged += StretchedGrid_SizeChanged;
        }

        private void StretchedGrid_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            double newWidth = e.NewSize.Width;
            if (!double.IsNaN(MaxContentWidth))
            {
                if (newWidth > MaxContentWidth)
                {
                    newWidth = MaxContentWidth;
                }
            }
            ContentHost.Width = newWidth;
            ContentHost.Height = e.NewSize.Height;                
        }

        public void SetPDFViewCtrl(PDFViewCtrl ctrl)
        {
            ViewModel.SetPDFViewCtrl(ctrl);
        }

        public void SetMagnifyingTool(MagnifyingTool tool)
        {
            ViewModel.SetMagnifyingTool(tool);
        }


        #region Dependency Properties

        public static readonly DependencyProperty MaxContentWidthProperty = DependencyProperty.Register(
          "MaxContentWidth",
          typeof(double),
          typeof(MagnifyingControl),
          new PropertyMetadata(double.NaN, new PropertyChangedCallback(OnMaxContentWidthChanged))
        );

        public double MaxContentWidth
        {
            get { return (double)GetValue(MaxContentWidthProperty); }
            set { SetValue(MaxContentWidthProperty, value); }
        }

        private static void OnMaxContentWidthChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            
        }



        #endregion Dependency Properties
    }
}
