﻿using System.Security;
using Windows.UI.Xaml.Controls;
using pdftron.PDF.Tools.Controls.ViewModels.Common;
using System.Threading.Tasks;
using Windows.Foundation;
using pdftron.PDF.Tools.Controls.ViewModels.Password;

// The User Control item template is documented at https://go.microsoft.com/fwlink/?LinkId=234236

namespace pdftron.PDF.Tools.Controls.Password
{
    public sealed partial class PdfPasswordUserControl : UserControl, IPasswordUserControl
    {
        private PdfPasswordViewModel _viewModel;

        public PdfPasswordUserControl()
        {
            InitializeComponent();
        }

        public ContentDialogResult DialogResultType { get; set; }

        public void SetViewModel(ViewModelBase viewModel)
        {
            _viewModel = (PdfPasswordViewModel)viewModel;
            _viewModel.PasswordHandled += PasswordHandled;
            DataContext = _viewModel;
        }

        private void PasswordHandled(bool success, string password, Deferral deferral)
        {
            try
            {
                if (success)
                {
                    _viewModel.ValidPassword = true;
                    _viewModel.UserPassword = password;
                    DialogResultType = ContentDialogResult.Primary;
                }
                else
                {
                    _viewModel.ValidPassword = false;
                    DialogResultType = ContentDialogResult.Secondary;
                }
            }
            finally
            {
                _viewModel.PasswordHandled -= PasswordHandled;
                deferral.Complete();
            }
        }
    }
}
