﻿using pdftron.PDF.Tools.Controls.ViewModels;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;


namespace pdftron.PDF.Tools.Controls
{
    public sealed partial class TextLinkDialog : ContentDialog
    {
        public TextLinkDialog(PDFDoc doc)
        {
            this.InitializeComponent();
            this.DataContext = ViewModel = new TextLinkViewModel(doc);
            IsPrimaryButtonEnabled = false;
        }

        public TextLinkViewModel ViewModel { get; set; }

        private void ContentDialog_PrimaryButtonClick(ContentDialog sender, ContentDialogButtonClickEventArgs args)
        {
        }

        private void ContentDialog_SecondaryButtonClick(ContentDialog sender, ContentDialogButtonClickEventArgs args)
        {
        }

        private void TextBox_BeforeTextChanging(TextBox sender, TextBoxBeforeTextChangingEventArgs args)
        {
            if (HyperlinkRadio.IsChecked.Value)
                return;

            if (string.IsNullOrWhiteSpace(args.NewText))
                return;

            var lastChar = args.NewText.Last();
            if (char.IsDigit(lastChar) == false)
                args.Cancel = true;

            int val;
            if (int.TryParse(args.NewText, out val))
            {
                if (val == 0 || val > ViewModel.PageCount)
                    IsPrimaryButtonEnabled = false;
                else
                    IsPrimaryButtonEnabled = true;
            }            
        }

        private void GoToRadio_Checked(object sender, RoutedEventArgs e)
        {
            IsPrimaryButtonEnabled = false;
        }

        private void HyperlinkRadio_Checked(object sender, RoutedEventArgs e)
        {
            IsPrimaryButtonEnabled = true;
        }
    }
}
