﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

namespace pdftron.PDF.Tools.Controls
{
    public sealed partial class UserBookmarkControl : UserControl
    {
        static DependencyProperty ShowOverflowProperty =
          DependencyProperty.Register("ShowOverflow", typeof(bool),
          typeof(UserBookmarkControl), new PropertyMetadata(false, OnShowOverflowChanged));

        private static void OnShowOverflowChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            UserBookmarkControl ctrl = d as UserBookmarkControl;
            bool show = (bool)e.NewValue;
            if (ctrl != null)
            {
                if (show)
                {
                    ctrl.BookmarksListView.ItemTemplate = ctrl.Resources["BookmarkTemplateWithOverflow"] as DataTemplate;
                }
                else
                {
                    ctrl.BookmarksListView.ItemTemplate = ctrl.Resources["BookmarkTemplate"] as DataTemplate;
                }
            }
        }

        public bool ShowOverflow
        {
            get { return (bool)(GetValue(ShowOverflowProperty)); }
            set { SetValue(ShowOverflowProperty, value); }
        }

        private void FlyoutHostedButton_Clicked(object sender, RoutedEventArgs e)
        {
            DependencyObject host = sender as DependencyObject;
            while (host != null)
            {
                Popup flyout = host as Popup;
                if (flyout != null)
                {
                    flyout.IsOpen = false;
                    return;
                }
                FrameworkElement widget = host as FrameworkElement;
                if (widget != null)
                {
                    host = widget.Parent;
                }
                else
                {
                    return;
                }
            }
        }

    }
}
