﻿namespace pdftron.PDF.Tools.Controls.ViewModels.Common
{
    /// <summary>
    /// ComboboxItemViewModel
    /// </summary>
    public class ComboboxItemViewModel : ViewModelBase
    {
        private string _description;
        private string _name;
        private bool _selected;

        /// <summary>
        /// ctor
        /// </summary>
        /// <param name="description"></param>
        /// <param name="name"></param>
        /// <param name="selected"></param>
        public ComboboxItemViewModel(string description, string name, bool selected = false)
        {
            Description = description;
            Name = name;
            Selected = selected;
        }

        /// <summary>
        /// Description
        /// </summary>
        public string Description
        {
            get => _description;
            set => Set(ref _description, value);
        }

        /// <summary>
        /// Name
        /// </summary>
        public string Name
        {
            get => _name;
            set => Set(ref _name, value);
        }

        /// <summary>
        /// Selected
        /// </summary>
        public bool Selected
        {
            get => _selected;
            set => Set(ref _selected, value);
        }
    }
}
