﻿using pdftron.PDF.Tools.Controls.ViewModels.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Xaml.Media;

namespace pdftron.PDF.Tools.Controls.ViewModels
{
    public class CropItem : ViewModelBase
    {
        private ImageSource _Source;
        public ImageSource Source
        {
            get { return _Source; }
            set { Set(ref _Source, value); }
        }

        private double _Width;
        public double Width
        {
            get { return _Width; }
            set { Set(ref _Width, value); }

        }

        private double _Height;
        public double Height
        {
            get { return _Height; }
            set { Set(ref _Height, value); }
        }

        private int _Page;
        public int Page
        {
            get { return _Page; }
            set { Set(ref _Page, value); }
        }

        public CropItem(ImageSource source, double width, double height, int page) : this(page, width, height)
        {
            Source = source;
        }

        public CropItem(int page, double width, double height)
        {
            Page = page;
            Width = width;
            Height = height;
        }
    }
}
