﻿using pdftron.PDF.Tools.Controls.ViewModels.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace pdftron.PDF.Tools.Controls.ViewModels
{
    public class TextLinkViewModel : ViewModelBase
    {
        private string mHyperlinkHintText = "www.example.com";
        private string mGoToHintText = "page number";
        private int mPageCount;

        public TextLinkViewModel(PDFDoc doc)
        {
            // Cache page count
            mPageCount = doc.GetPageCount();

            // Default to HyperLink
            HintText = mHyperlinkHintText;
            IsHyperlink = true;
        }

        #region Properties                

        public int PageCount { get { return mPageCount; } }

        private string _text = string.Empty;
        public string Text 
        {
            get { return _text; }
            set { _text = value; RaisePropertyChanged(); }
        }

        private bool _isHyperlink = false;
        public bool IsHyperlink
        {
            get { return _isHyperlink; }
            set 
            {
                _isHyperlink = value;

                if (IsHyperlink)
                {
                    Text = string.Empty;
                    _isGoToPage = false;
                    HintText = mHyperlinkHintText;
                }

                RaisePropertyChanged(); 
            }
        }

        private bool _isGoToPage = false;
        public bool IsGotoPage
        {
            get { return _isGoToPage; }
            set
            {
                _isGoToPage = value;

                if (IsGotoPage)
                {
                    Text = string.Empty;
                    IsHyperlink = false;
                    HintText = mGoToHintText + "(1 - " + mPageCount + ")";
                }

                RaisePropertyChanged(); 
            }
        }

        private string _HintText = string.Empty;
        public string HintText
        {
            get { return _HintText; }
            set { _HintText = value; RaisePropertyChanged(); }
        }

        #endregion
    }
}
