﻿using pdftron.PDF.Tools.Controls.Resources;

namespace pdftron.PDF.Tools.Controls.ViewModels
{
    public class ThumbInfo : ObservableCollectionWithAsyncResource<ThumbnailItem, ThumbInfo>.IResourceHolder
    {
        public int PageNumber { get; set; }

        public int W { get; set; }

        public int H { get; set; }

        public int ByteSize { get; }

        public double TotalSize => ByteSize;

        public ThumbnailItem SourceItem { get; set; }

        public ThumbInfo(int pageNumber, int w, int h, ThumbnailItem item)
        {
            PageNumber = pageNumber;
            W = w;
            H = h;
            ByteSize = W * H * 4;
            SourceItem = item;
        }
    }
}
