﻿using pdftron.PDF.Tools.Controls.ViewModels.Common;
using Windows.UI;
using Windows.UI.Xaml.Media;

namespace pdftron.PDF.Tools.Controls.ViewModels.Viewer.ColorMode
{
    public class CustomColorIconViewModel : ViewModelBase
    {
        private Color _background;
        private Color _foreground;
        private bool _isSelected;
        private bool _isLoadDefault;

        public CustomColorIconViewModel(Color background, Color foreground)
        {
            Background = CloneColor(background);
            Foreground = CloneColor(foreground);
        }

        public Color Background
        {
            get => _background;
            set
            {
                if (Set(ref _background, value))
                    RaisePropertyChanged(nameof(BackgroundBrush));
            }
        }
        public Color Foreground
        {
            get => _foreground;
            set
            {
                if (Set(ref _foreground, value))
                    RaisePropertyChanged(nameof(ForegroundBrush));
            }
        }

        public SolidColorBrush BackgroundBrush => new SolidColorBrush(Background);

        public SolidColorBrush ForegroundBrush => new SolidColorBrush(Foreground);

        public bool IsSelected
        {
            get => _isSelected;
            set => Set(ref _isSelected, value);
        }

        public bool IsLoadDefault
        {
            get => _isLoadDefault;
            set => Set(ref _isLoadDefault, value);
        }

        private Color CloneColor(Color color) => new Color { A = color.A, R = color.R, G = color.G, B = color.B };
    }
}
