﻿using pdftron.PDF.Tools.Controls.ViewModels.Viewer.Search;
using Windows.Foundation;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Input;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

namespace pdftron.PDF.Tools.Controls.Viewer.Dialogs
{
    public sealed partial class FindTextDialog : UserControl
    {
        public FindTextDialog()
        {
            InitializeComponent();
        }

        public bool DoesSearchBoxHaveFocus => SearchTermTextBox.FocusState != FocusState.Unfocused;

        // Focus is awkward in the VM, so it's easier to wire it here
        public void SetFocus()
        {
            SearchTermTextBox.Focus(FocusState.Programmatic);
        }

        private void SearchBox_Loaded(object sender, RoutedEventArgs e)
        {
            SearchTermTextBox.Focus(FocusState.Programmatic);
            if (sender is TextBox control)
            {
                TextBox textBox = sender as TextBox;
                textBox.SelectAll();
            }
        }

        // Wrapping text box under appbar button doesn't allow spaces, so work around it.
        private void SearchTermTextBox_KeyDown(object sender, KeyRoutedEventArgs e)
        {
            //TextBox textBox = sender as TextBox;
            //if (!String.IsNullOrWhiteSpace(textBox.Text) && e.Key == Windows.System.VirtualKey.Space)
            //{
            //    int selStart = textBox.SelectionStart;
            //    string preString = textBox.Text.Substring(0, selStart);
            //    string postString = textBox.Text.Substring(selStart + textBox.SelectionLength);
            //    textBox.Text = preString + " " + postString;
            //    textBox.SelectionStart = selStart + 1;
            //    textBox.SelectionLength = 0;
            //}
        }
        private void SearchBox_Unloaded(object sender, RoutedEventArgs e)
        {
            if (sender is TextBox control)
            {
                FindTextViewModel viewModel = (FindTextViewModel)control.DataContext;

                if (viewModel.IsPrevNextAvailable)
                    return;

                viewModel.ClearViewModel();
            }
        }
    }
}
