﻿using System;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Media;

namespace pdftron.PDF.Tools.Converters
{
    public class BooleanToBackgroundColorConverter : IValueConverter
    {
        public static readonly DependencyProperty SelectedBrushProperty = DependencyProperty.RegisterAttached(
            "SelectedBrush",
            typeof(SolidColorBrush),
            typeof(BooleanToBackgroundColorConverter),
            new PropertyMetadata(null));

        public SolidColorBrush SelectedBrush { get; set; }

        public static readonly DependencyProperty UnSelectedBrushProperty = DependencyProperty.RegisterAttached(
            "UnSelectedBrush",
            typeof(SolidColorBrush),
            typeof(BooleanToBackgroundColorConverter),
            new PropertyMetadata(null));

        public SolidColorBrush UnSelectedBrush { get; set; }

        public object Convert(object value, Type targetType, object parameter, string language)
        {
            bool isSelected = System.Convert.ToBoolean(value);
            if (isSelected)
            {
                return SelectedBrush;
            }
            else
            {
                return UnSelectedBrush;
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language) => value is SolidColorBrush brush && brush.Color == SelectedBrush.Color;
    }
}
