﻿using System;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Data;

namespace pdftron.PDF.Tools.Converters
{
    public class DoubleToThicknessConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            string val = System.Convert.ToString(value);
            string[] margins = val.Split(',');
            if (margins.Length == 1 || margins.Length == 2)
            {
                //Uniform margin
                double uniformLength = System.Convert.ToDouble(margins[0]);
                return new Thickness(uniformLength);
            }
            else
            {
                //Un-uniform margin
                double left = System.Convert.ToDouble(margins[0]);
                double top = System.Convert.ToDouble(margins[1]);
                double right = System.Convert.ToDouble(margins[2]);
                double bottom = System.Convert.ToDouble(margins[3]);

                return new Thickness(left, top, right, bottom);
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language) => DependencyProperty.UnsetValue;
    }
}
