﻿using System;
using Windows.UI.Xaml.Data;

namespace pdftron.PDF.Tools.Converters
{
    public class EnumToBooleanConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            string val = value.ToString();
            string param = parameter as string;
            return !string.IsNullOrEmpty(val) && !string.IsNullOrEmpty(param) && val.Equals(param, StringComparison.OrdinalIgnoreCase);
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            bool val = System.Convert.ToBoolean(value);
            string param = parameter.ToString();
            return val ? param : null;
        }
    }
}
