﻿using pdftron.PDF.Tools.Controls.Viewer;
using System;
using Windows.ApplicationModel.Resources;
using Windows.UI.Xaml.Data;

namespace pdftron.PDF.Tools.Converters.Outline
{
    public class NumberToColumnNameConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            ResourceLoader loader = ResourceLoader.GetForCurrentView("pdftron.PDF.Tools/Resources");
            int numColumns = ViewerSettings.OutlineDialogNumThumbnailColumns;
            try
            {
                numColumns = System.Convert.ToInt32(value);
            }
            catch
            {
                //swallow exception
            }

            string formatString;
            if (numColumns == 1)
            {
                formatString = loader.GetString("OutlineDialog_SelectNumberOfThumbnailColumns_Singular");
            }
            else
            {
                formatString = loader.GetString("OutlineDialog_SelectNumberOfThumbnailColumns_Plural");
            }

            return string.Format(formatString, numColumns);
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            // Not used
            return 1;
        }
    }
}
