﻿using System;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Data;

namespace pdftron.PDF.Tools.Converters
{
    public class RichTextIconNameConverter : IValueConverter
    {
        /// <summary>
        /// This converter is for getting the Icon name string and converting it to unicode of glyph-icon.tff (PDFTtron SVG font)
        /// </summary>
        /// <param name="value"></param>
        /// <param name="targetType"></param>
        /// <param name="parameter"></param>
        /// <param name="language"></param>
        /// <returns></returns>
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            if (value == null)
                return null;

            string val = value.ToString();

            switch (val)
            {
                case "Bold":
                    return "\uE843";
                case "Italic":
                    return "\uE844";
                case "Underline":
                    return "\uE735";
                case "Strikethrough":
                    return "\uE732";

                default:
                    return "";
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language) => DependencyProperty.UnsetValue;
    }
}
