﻿using System;
using Windows.ApplicationModel.Resources;
using Windows.UI.Xaml.Data;

namespace pdftron.PDF.Tools.Converters
{
    public class StringToResourceConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {

            if (value is string key)
            {
                if (string.IsNullOrEmpty(key))
                    return string.Empty;

                if (parameter is string name)
                {
                    ResourceLoader loader = ResourceLoader.GetForCurrentView(name);
                    string str = loader.GetString(key);
                    if (string.IsNullOrEmpty(str))
                    {
                        loader = ResourceLoader.GetForCurrentView();
                        return loader.GetString(key);
                    }

                    return str;
                }
                else
                {
                    ResourceLoader loader = ResourceLoader.GetForCurrentView();
                    return loader.GetString(key);
                }
            }

            return string.Empty;
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language) => value;
    }
}
