﻿using pdftron.PDF.Annots;
using System;
using Windows.UI.Xaml.Controls;

using PDFRect = pdftron.PDF.Rect;

namespace pdftron.PDF.Tools.Utilities
{
    public class NoteDialogBase : UserControl
    {
        protected PDFViewCtrl _PDFViewCtrl;
        protected ToolManager _ToolManager;
        protected string _OriginalText = string.Empty;
        protected bool _CanDelete = false;
        protected bool _CanSaveEmpty = false;
        protected bool _TextHasChanged = false;

        public bool FocusWhenOpened { get; set; }

        private bool _InitialAnnot = false;
        public bool InitialAnnot
        {
            get { return _InitialAnnot; }
            set { _InitialAnnot = value; }
        }

        public NoteDialogBase()
        {

        }

        public enum NotedialogResults
        {
            Canceled,
            Changed,
            Deleted,
        }

        public delegate void NoteClosedDialogHandler(NotedialogResults result, string newText);
        public event NoteClosedDialogHandler NoteClosed = delegate { };
        protected void RaiseNoteClosedEvent(NotedialogResults result, string newText)
        {
            if (NoteClosed != null)
            {
                NoteClosed(result, newText);
            }
        }

        public NoteDialogBase(string oldText, bool canDelete, bool canSaveEmpty, PDFViewCtrl ctrl, ToolManager toolManager)
        {
            if (oldText != null)
            {
                _OriginalText = oldText;
            }
            _CanDelete = canDelete;
            _CanSaveEmpty = canSaveEmpty;
            _PDFViewCtrl = ctrl;
            _ToolManager = toolManager;
        }

        public virtual void Close()
        {
            _ToolManager.mCurrentNoteDialog = null;
        }
    }
}
