﻿using System;
using Windows.UI.Core;
using Windows.UI.ViewManagement;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at https://go.microsoft.com/fwlink/?LinkId=234238

namespace pdftron.PDF.Tools.Utilities
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class NewWindowPage : Windows.UI.Xaml.Controls.Page
    {
        ApplicationView _currentAppView;
        IMultiWindowUserControl _userControl;

        public NewWindowPage()
        {
            this.InitializeComponent();

            _currentAppView = ApplicationView.GetForCurrentView();
            _currentAppView.Consolidated += ApplicationView_Consolidated;
        }

        protected override async void OnNavigatedTo(NavigationEventArgs e)
        {
            if (e.Parameter == null)
                return;

            // This Dispatcher is identical to "CoreApplication.MainView.Dispatcher"
            if (Window.Current.Dispatcher.HasThreadAccess)
            {
                if (e.Parameter.GetType().BaseType.Equals(typeof(UserControl)))
                    _userControl = e.Parameter as IMultiWindowUserControl;

                if (_userControl != null)
                {
                    this.Content = (UIElement)_userControl;
                }
            }
            else
            {
                await Window.Current.Dispatcher.RunAsync(CoreDispatcherPriority.Normal, () =>
                {
                    if (e.Parameter.GetType().BaseType.Equals(typeof(UserControl)))
                        _userControl = e.Parameter as IMultiWindowUserControl;

                    if (_userControl != null)
                        this.Content = (UIElement)_userControl;
                });
            }
        }

        private async void ApplicationView_Consolidated(ApplicationView sender, ApplicationViewConsolidatedEventArgs args)
        {
            MultiWindowManager.Instance.UntrackWindowById(sender.Id);

            // Enter here when this window is removed from the list of recently used apps, or if the user executes a close gesture on this window
            await sender.TryConsolidateAsync();
        }
    }
}
