﻿using Windows.Foundation.Metadata;
using Windows.UI.Composition;

namespace pdftron.PDF.Tools.Utilities
{
    public class WindowsInfo
    {
        private static WindowsInfo _windowsInfo;

        private WindowsInfo()
        {
            if (ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 9))
            {
                Build = Build.V1909;
            }
            else if (ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 8))
            {
                Build = Build.V1903;
            }
            else if (ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 7))
            {
                Build = Build.V1809;
            }
            else if (ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 6))
            {
                Build = Build.V1803;
            }
            else if (ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 5))
            {
                Build = Build.V1709;
            }
            else if (ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 4))
            {
                Build = Build.V1703;
            }
            else if (ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 3))
            {
                Build = Build.V1607;
            }
            else if (ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 2))
            {
                Build = Build.V1511;
            }
            else if (ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 1))
            {
                Build = Build.V1507;
            }
            else
            {
                Build = Build.Unknown;
            }
        }

        public static Build Build { get; private set; }

        public static WindowsInfo RetrieveApiInfo() => _windowsInfo ?? (_windowsInfo = new WindowsInfo());
    }

    public enum Build
    {
        Unknown = 0,
        V1507 = 10240, // Threshold1
        V1511 = 10586, // Threshold2
        V1607 = 14393, // Redstone 1 - Anniversary
        V1703 = 15063, // Redstone 2 - Creators
        V1709 = 16299, // Redstone 3 - FallCreators
        V1803 = 17134,
        V1809 = 17763,
        V1903 = 18362,
        V1909 = 18363,
        V2004 = 19041,
        V20H2 = 19042
    }
}
